---------------------------------------------------------------------------
-- This VHDL file was developed by Daniel Llamocca (2013).  It may be
-- freely copied and/or distributed at no cost.  Any persons using this
-- file for any purpose do so at their own risk, and are responsible for
-- the results of such use.  Daniel Llamocca does not guarantee that
-- this file is complete, correct, or fit for any particular purpose.
-- NO WARRANTY OF ANY KIND IS EXPRESSED OR IMPLIED.  This notice must
-- accompany any copy of this file.
--------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use ieee.std_logic_arith.all;
 
ENTITY tb_my_wallace_4bit IS
END tb_my_wallace_4bit;
 
ARCHITECTURE behavior OF tb_my_wallace_4bit IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT my_wallace_4bit
    PORT(
         A : IN  std_logic_vector(3 downto 0);
         B : IN  std_logic_vector(3 downto 0);
         P : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal A : std_logic_vector(3 downto 0) := (others => '0');
   signal B : std_logic_vector(3 downto 0) := (others => '0');

 	--Outputs
   signal P : std_logic_vector(7 downto 0);
	
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: my_wallace_4bit PORT MAP (
          A => A,
          B => B,
          P => P
        );

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	
      -- insert stimulus here
		li: for i in 0 to 15 loop
				 A <= conv_std_logic_vector(i,4);
				 lj: for j in 0 to 15 loop
							B <= conv_std_logic_vector (j,4); wait for 20 ns;
					  end loop;
			 end loop;
		A <= x"0"; B <= x"0"; wait for 20 ns;

      wait;
   end process;

END;
